/***************************************************************************
 *   Copyright (C) 2004 by Johan Maes - ON4QZ                              *
 *   on4qz@telenet.be                                                      *
 *   http://users.telenet.be/on4qz                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef CONFIGDIALOG_H
#define CONFIGDIALOG_H
#include <qobject.h>
#include "sstvparam.h"

/** @author Johan Maes - ON4QZ */

extern QString docPath; 
extern QString audioPath;
extern QString txImagePath;
extern QString rxImagePath;
extern QString templatePath;
extern QString defaultImageFormat;
extern int samplingrate;
extern bool useUTC;
extern double rxClock;
extern double txClock;
extern QString audioDevice;
extern QString serialPort;
extern QString callsign;
extern QString toCall;
extern QString toOperator; 
extern QString rst;
extern QString lastname;
extern QString locator;
extern QString firstname;
extern QString qth;
extern QString qsstv_version;
extern QString cwText;
extern int cwTone;
extern int cwWPM;
extern bool enableFTP;
extern int ftpPort;
extern QString ftpRemoteHost;
extern QString ftpRemoteDirectory;
extern QString ftpLogin;
extern QString ftpPassword;
extern QString ftpFilename;
extern QString ftpDefaultImageFormat;
extern bool repeaterEnable;
extern int repeaterImageInterval;
extern sstvMode repeaterTxMode;
extern QString repeaterImage1;
extern QString repeaterImage2;
extern QString repeaterImage3;
extern QString repeaterImage4;
extern QString repeaterAcknowledge;
extern QString repeaterTemplate;

class configForm;

//! configuration Dialog

class configDialog: public QObject 
{
Q_OBJECT
public:
    configDialog(QWidget *parent = 0, const char *name = 0);
    ~configDialog();
		void writeSettings();
		void readSettings();
		void exec();

		
public slots:
		void slotBrowseAudioPath();
		void slotBrowseDocPath();
		void slotBrowseRxImagePath();
		void slotBrowseTxImagePath();
		void slotBrowseTemplatePath();
		void slotBrowseRp1();
		void slotBrowseRp2();
		void slotBrowseRp3();
		void slotBrowseRp4();
		void slotBrowseRpTemplate();
private:
		configForm *conf;
		void setup();
		void apply();
		void getParams();
		void setParams();

};



#endif
