/***************************************************************************
 *   Copyright (C) 2004 by Johan Maes - ON4QZ                              *
 *   on4qz@telenet.be                                                      *
 *   http://users.telenet.be/on4qz                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef GALERYMAINWINDOW_H
#define GALERYMAINWINDOW_H

#include <qmainwindow.h>
#define NUMTHUMBS 12
class galeryForm;
class thumbImage;
class imageView;

/**
Mainwindow for the image galery

@author Johan Maes - ON4QZ
*/
class galeryMainWindow : public QMainWindow
{
public:
    galeryMainWindow();
    ~galeryMainWindow();
		void init();
		void closeEvent(QCloseEvent *) 	{}
		void writeSettings();
		void readSettings();
		galeryForm *gf;
		void putRxImage(QString fn);
		QString getTemplateFileName(int);
		
private:
	void initView();
	void initActions();
	void initToolbar();
	void initMenubar();
	void getParams();
	void setParams();
	thumbImage *rxThumbsArray[NUMTHUMBS];
	thumbImage *txThumbsArray[NUMTHUMBS];
	thumbImage *templateThumbsArray[NUMTHUMBS];
	int rxIndex;
};

#endif
