/***************************************************************************
 *   Copyright (C) 2004 by Johan Maes - ON4QZ                              *
 *   on4qz@telenet.be                                                      *
 *   http://users.telenet.be/on4qz                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef IMAGEVIEW_H
#define IMAGEVIEW_H

#include <qscrollview.h>
#include <qpixmap.h>
#include <qimage.h>

/**
Class to display and manipulate images 

@author Johan Maes - ON4QZ
*/
class imageView : public QScrollView
{
Q_OBJECT
public:
	imageView(QWidget *parent = 0, const char *name = 0);
	~imageView();
//	void setPixmap( const QPixmap &pix );
	unsigned int *getLineAddress(uint lineCounter);
	void drawContents( QPainter *p, int cx, int cy , int cw, int ch);
	void drawFullContents();
	void clearToBottom(QColor color);
	void clearBackground();
	void showLine();
	//void showLine(int line,int nbrlines);
	void setNewSize(int w, int h);
	void showImage(QImage *ip);
//	QPixmap pixmap;
	QImage image;
signals:
	void newSize(unsigned int w, unsigned int h);
private:
	bool hasContent;
};

#endif
