/***************************************************************************
 *   Copyright (C) 2004 by Johan Maes - ON4QZ                              *
 *   on4qz@telenet.be                                                      *
 *   http://users.telenet.be/on4qz                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <qapplication.h>
#include <qnetwork.h>
#include "rxmainwindow.h"
#include "txmainwindow.h"
#include "galerymainwindow.h"
#include "qsstvglobal.h"
#include "configdialog.h"
#include "qcdestyle.h"

int main( int argc, char ** argv )
{
		int result;
    QApplication::setColorSpec( QApplication::ManyColor );
		QApplication a( argc, argv );
		a.setStyle( new QCDEStyle );
		// creating 3 seperate MainWindows
		confDiag=new configDialog(); // must be the first one to be started
		qInitNetworkProtocols ();
    rxMW = new rxMainWindow();
		txMW = new txMainWindow();
		galMW= new galeryMainWindow();
		
    rxMW->setCaption( "QSSTV RX" );
		txMW->setCaption( "QSSTV TX" );
		galMW->setCaption( "QSSTV Gallery" );
		rxMW->init();
		txMW->init();
		galMW->init();
		txMW->show();
		galMW->show();
		rxMW->show();
		rxMW->setActiveWindow();
		rxMW->raise();
		//a.connect( &a, SIGNAL(lastWindowClosed()), &a, SLOT(quit()) );
		rxMW->setIcon(QPixmap::fromMimeSource("qsstv.png"));
		txMW->setIcon(QPixmap::fromMimeSource("qsstv.png"));
		galMW->setIcon(QPixmap::fromMimeSource("qsstv.png"));
		result=a.exec();
		return result;
}
