/***************************************************************************
 *   Copyright (C) 2004 by Johan Maes - ON4QZ                              *
 *   on4qz@telenet.be                                                      *
 *   http://users.telenet.be/on4qz                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef NCO_H
#define NCO_H
#include <math.h>

/**
@author Johan Maes ON4QZ
*/
class nco  // numerical controlled oscillator
{
 public:
  nco(float freq=0.5)
    {
      init(freq);
    }
  ~nco()
    {
    }
  void init(float frequency)
    {
      w=(2*frequency*M_PI);
      b=2.*cos(w);
      s1=sin(-w);
      s2=sin(-2.*w);
      c1=sin(M_PI/2.-w);
      c2=sin(M_PI/2.-2.*w);   
    }
  void getSinCos(float &sinVal,float &cosVal)
    {
      sinVal=b*s1-s2;
      s2=s1;
      s1=sinVal;
      cosVal=b*c1-c2;
      c2=c1;
      c1=cosVal;
    }
  float getSine()
    {
      float sinVal=b*s1-s2;
      s2=s1;
      return(s1=sinVal);
    }
	void multiply(float &I, float &Q,float val)
		{
			float t=b*s1-s2;
			I=val*t;
			s2=s1;
			s1=t;
			t=b*c1-c2;
			c2=c1;
			Q=val*t;
			c1=t;
  	}

 private:
  float w;
  float b;
  float s1,s2;
  float c1,c2;
};




#endif
