/***************************************************************************
 *   Copyright (C) 2004 by Johan Maes - ON4QZ                              *
 *   on4qz@telenet.be                                                      *
 *   http://users.telenet.be/on4qz                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef RXFUNCTIONS_H
#define RXFUNCTIONS_H
#include <qobject.h>
#include <qtimer.h>
#include "rxtxfunctions.h"
#include "qsstvglobal.h"

// rxFunctions @author Johan Maes - ON4QZ 


class debugPlot;
class vuMeter;
class modeBase;
class syncDisplay;
class ftpInterface;


//! rxfunctions class to be documented
class rxFunctions : public  rxtxFunctions
{
		Q_OBJECT
public:
    rxFunctions(QObject *parent = 0, const char *name = 0);
    ~rxFunctions();
		void process(rxtxState stat);
		void calibrate();
		void	setoffsetMeterFrame(vuMeter *);
		void  setvuMeterFrame(vuMeter *);
		void setSyncDisplayFrame(syncDisplay *);
		bool isBusy() {return busy;}
public slots:
	void slotStop();
	void slotUpdateVolume();
	void slotProcessLoop();
	void slotUpdateOffset(int ofs,int pos);
	void slotUpdateSyncDisplay(unsigned int pos);
	void slotResetRepeater();
signals:
	void statusMessage(QString message);
private:
	float f;
	bool s;
	unsigned int tempPos;
	//unsigned int pos;
	vuMeter *vuMeterPtr;
	vuMeter *offsetMeterPtr;
	syncDisplay *syncDisplayFrame;
	unsigned char visCode;
	void imageSave();
	QTimer *processTimer;
	QTimer *volumeTimer;
	QTimer *repeaterToneTimeout;
	bool endSync;
	ftpInterface *ftpIntf;
	bool busy;
	bool repeaterToneDetected;
	unsigned int oldSyncPosition;
};



#endif
