/***************************************************************************
 *   Copyright (C) 2004 by Johan Maes - ON4QZ                              *
 *   on4qz@telenet.be                                                      *
 *   http://users.telenet.be/on4qz                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef RXMAINWINDOW_H
#define RXMAINWINDOW_H

#include <qmainwindow.h>
#include <qaction.h>
#include <qpopupmenu.h>
#include <qtoolbar.h>
#include <qmenubar.h>
#include <qlabel.h>
#include <qprinter.h>

class rxForm;
class rxFunctions;
class imageView;

/**
Mainwindow for receiver

@author Johan Maes - ON4QZ
*/
class rxMainWindow : public QMainWindow
{
	Q_OBJECT
public:
    rxMainWindow();
    ~rxMainWindow();
		void init();
		void writeSettings();
		void readSettings();
		void closeEvent(QCloseEvent *);
		imageView *getImagePtr();
		void restartAfterAck();
		bool isBusy();

		
public slots:
	void slotConfigure();
	void slotStartRX();
	void slotStopRX();
	void slotHelpAbout();
	void slotFileRaw();
	void slotFileQuit();
	void slotRXFromFile();
	void slotDisplayStatusMessage(QString);
	void slotCalibrate();
	void slotNewSize(unsigned int,unsigned int);
	void slotGetParams();
	void slotShowPlot();
	void slotPrintRX();
	void slotFileSave();
	void slotErase();
	void slotZoom();
	void slotUserGuide();
private:
	void initView();
	void initActions();
	void initToolbar();
	void initMenubar();
	void setParams();	
	QAction *fileQuit;
	QAction	*configure;
	QAction *startRX;
	QAction *stopRX;
	QAction *fileSave;
	QAction *erase;
	QAction *zoom;
	QAction *userGuide;
#ifdef DEBUGQSSTV
	QAction *readFile;
	QAction *outputRaw;
	QAction *showPlot;
#endif
	QAction *calibrate;
	QAction *printRX;
	QAction *helpAboutApp;
	QToolBar *toolBar;
	QPopupMenu *fileMenu;
	QPopupMenu *optionMenu;
	QPopupMenu *actionMenu;
	QPopupMenu *helpMenu;
	rxFunctions *rxf;
	rxForm *cv;
	QLabel *permText;

};

#endif
