/***************************************************************************
 *   Copyright (C) 2004 by Johan Maes - ON4QZ                              *
 *   on4qz@telenet.be                                                      *
 *   http://users.telenet.be/on4qz                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "syncdisplay.h" 
#include <qpainter.h>
#include <math.h>
#include "qsstvglobal.h"
#include "dspfunctions.h"

#define FMIN 1000
#define FMAX 2600

void syncDisplay::paintEvent(QPaintEvent *p)
{
  draw();
  QFrame::paintEvent(p);
//	debug("drawing syncDisplay");
}



void syncDisplay::setData(unsigned int pos)
{
	unsigned int i;
	int temp;
	uint start=(pos-SYNCBUFFERSIZE/2)&INPUTINDEXMASK;
	for (i=0;i<SYNCBUFFERSIZE;i++)
		{
			temp=(int)dsp->getDemodulatedDataAt(start+i);
			if (temp<FMIN) temp=FMIN;
			else if (temp>FMAX) temp=FMAX;
			temp-=FMIN;
			dataBuffer[i]=temp;
		}
	repaint(FALSE);
	enabled=TRUE;
}


void syncDisplay::draw()
{
  int i,t;
	if(!enabled) return;
	QPainter p;
	
  // the offset should be in the middle
/*	for (i=0,j=(rp-SYNCBUFFERSIZE/2);i<SYNCBUFFERSIZE;i++)
    {
     temp=filteredData[j];
     temp-=(double)FMIN;
     temp=(temp<0 ? 0 : temp);
     dataBuffer[i]=(uint)(temp);
     j++;
    }*/
  QPointArray syncArray(SYNCBUFFERSIZE);
  int h=contentsRect().height();
  int w=contentsRect().width();
  int bw=lineWidth();
  p.begin(this);
  p.eraseRect(contentsRect());
  p.setPen(red);
  // We start at 1000 Hz
  // draw 1200 Line

  t=bw+h-h*(1200-FMIN)/(FMAX-FMIN);
  p.drawLine(bw,t,w,t);

  t=bw+h-h*(1500-FMIN)/(FMAX-FMIN);
  p.drawLine(bw,t,w,t);

  t=bw+h-h*(2300-FMIN)/(FMAX-FMIN);
  p.drawLine(bw,t,w,t);  
  p.setPen(green);
  t=bw+w/2;
  p.drawLine(t,bw,t,h+bw);
  for (i=0;i<SYNCBUFFERSIZE;i++)
    {
      t=bw+h-h*dataBuffer[i]/(FMAX-FMIN);
      t=(t>=h ? h : t);
      t=(t<bw ? bw : t);
      syncArray.setPoint(i,bw+i*w/SYNCBUFFERSIZE,t);
    } 
  p.setPen(green);
  p.drawPolyline(syncArray);
  p.end();
}
