/***************************************************************************
 *   Copyright (C) 2004 by Johan Maes - ON4QZ                              *
 *   on4qz@telenet.be                                                      *
 *   http://users.telenet.be/on4qz                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef THUMBIMAGE_H
#define THUMBIMAGE_H

#include <qframe.h>
#include <qstring.h>
#include <qimage.h>
#include <qsettings.h>
#include <qpopupmenu.h>

class editor;


	

class thumbImage : public QFrame
{
	Q_OBJECT
public:
	/*! thumbnail type */
		enum thumbType
		 {
				RXTHUMB, /*!< thumbnail for receiver. */
				TXTHUMB,/*!< thumbnail for transmitter. */
				TEMPLATETHUMB /*!< thumbnail for template. */
			};
    thumbImage(QWidget *parent,const char *name);
    ~thumbImage();
		void setFilename(QString fn,QString ipath);
		void mousePressEvent( QMouseEvent *e );
    void load();
		void readSettings(QSettings *qs);
		void writeSettings(QSettings *qs);
		void getParams();
		void setParams();
		void setType(thumbType t);
		QString getFilename() { return filename;}
		
public slots:
    void paintEvent( QPaintEvent *e );
    void resizeEvent(QResizeEvent *);
		void slotLoadDialog();
		void slotNew();
		void slotToTX();
//		void slotToRX();
		void slotEdit();
		void slotPrint();
		void slotDelete();
		void setImage(QImage *);
private:
	QString filename; //!< name of the file associated with the thumbnail 
	QString path;
	QImage scaledImage;
	QImage origImage;
	QString localName;
	thumbType ttype;
	void loadDialog(); 
	QPopupMenu *popup;
	editor *ed;
private slots:
    void slotProperties();
};

#endif
