/***************************************************************************
 *   Copyright (C) 2004 by Johan Maes - ON4QZ                              *
 *   on4qz@telenet.be                                                      *
 *   http://users.telenet.be/on4qz                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef TXFUNCTIONS_H
#define TXFUNCTIONS_H

#include "rxtxfunctions.h"
#include <qimage.h>
#include <qprogressbar.h>
#include <qtimer.h>

/**
@author Johan Maes - ON4QZ
*/
class modeBase;
class thumbImage;

enum etxPhase {HEADER,VISCODE,LINE,TAIL,CW,DELSTOP,STOP,END,DELAY};

class txFunctions : public  rxtxFunctions
{
Q_OBJECT
public:
	txFunctions(QProgressBar *pb,QObject *parent = 0, const char *name = 0);
	~txFunctions();
	void process();
	void sendCW(QString st);
	void setModeIndex(sstvMode mi);
	sstvMode getModeIndex() { return selectedMode;}
	int templateIndex;
	bool useTemplate;
	bool useTimestamp;
	bool done;
	bool busy;
	void addTemplate(int t);
	void applyTemplate();

	void stop();
	void setImage(QImage *ima);
	void 	setExistingImage();
	QImage *getImage()
		{
			return orgImage;
		}
	void sendTone(float freq,float duration);
	void sendAlignement();
public slots:
	void slotTransmit();
	void slotSendCW();
signals:
	void statusMessage(QString message);
private:
	QImage *orgImage;
	QImage *resultImage;
	thumbImage *thumbImPtr;
	//	sstvMode modeIndex;
	QTimer *txTimer;
	etxPhase txPhase;
	bool singleTone;
	float txFreq;
	float txDur;
	bool 	multiTone;
	float txFreqb;
	float txDurb;
	QProgressBar *pbPtr;
	
};

#endif
