/***************************************************************************
 *   Copyright (C) 2004 by Johan Maes - ON4QZ                              *
 *   on4qz@telenet.be                                                      *
 *   http://users.telenet.be/on4qz                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef TXMAINWINDOW_H
#define TXMAINWINDOW_H

#include <qmainwindow.h>
#include <qaction.h>
#include <qpopupmenu.h>
#include <qtoolbar.h>
#include <qmenubar.h>
#include "sstvparam.h"

class txForm;
class txFunctions;
class imageView;
class editor;


/**
Mainwindow for transmitter

@author Johan Maes - ON4QZ
*/
class txMainWindow : public QMainWindow
{
	Q_OBJECT
public:
    txMainWindow();
    ~txMainWindow();
		void init();
		void writeSettings();
		void readSettings();
		imageView *getImagePtr();
		void closeEvent(QCloseEvent *) 	{}
		void sendCW(QString &st);
		void repeat(QImage *im,sstvMode sm);
		void setImage(QString fn);
		void setImage(QImage *ima);

public slots:
	void slotStartTX();
	void slotStartTXFile();
	void slotStopTX();
	void slotDisplayStatusMessage(QString);
	void slotModeChanged(int );
	void slotTemplateChanged(int);
	void slotTemplateCBChanged(bool b);
	void slotGenerateSignal();
	void slotGenerateRepeaterTone();
	void slotAlignementSignal();
	void slotEdit();
	
	void slotCallChanged(const QString &);
	void slotOperatorChanged(const QString &);
	void slotRSTChanged(const QString &);
	void slotGetParams();
	void slotRepeaterTimer();
	void slotFileOpen();
private:
	void initView();
	void initActions();
	void initToolbar();
	void initMenubar();
	
	void setParams();
	QAction *startTX;
#ifdef DEBUGQSSTV	
	QAction *startTXFile;
#endif
	QAction *stopTX;
	QAction *edit;
	QAction *alignement;
//	QAction *readFile;
	QAction *generateSignal;
	QAction *repeaterTone;
	QAction *fileOpen;
	QToolBar *toolBar;
	QPopupMenu *fileMenu;
//QPopupMenu *optionMenu;
	QPopupMenu *actionMenu;	
	txForm *cv;
	txFunctions *txf;
	editor *ed;
	QTimer *repeaterTimer;
	int repeaterIndex;

};

#endif
